/*Ŀ
 ݳ                                                                      
 ݳ Program Name: UNARCH.PRG        Copyright: None                      
 ݳ Date Created: 12/22/95           Language: Clipper 5.3               
 ݳ Time Created: 20:03:19             Author: Kevin S Gallagher         
 Ĵ
 ݳ Please note that on extraction i write the file(s) to my ramdrive    
 ݳ which is D. This _must_ be changed to fit your environment. Also     
 ݳ there is no code for checking for overwritting existing files, it is 
 ݳ your job to code it. Concerning date/time stamps, they will not be   
 ݳ the same as the originals, but you could use a function froma 3rd    
 ݳ party library such as CA-Tools III or use Nanforum's ft_int86 to     
 ݳ correct time/date stamps                                             
 ݳ                                                                      
 ݳ There is an error in the "Guide to Clipper" NG that says that the    
 ݳ last parameter to BlobExport is optional, it is not optional so      
 ݳ instead of changing the header file it is easier to simply add the   
 ݳ last parameter.                                                      
 
            */

 
#include "include1.h"        

#include "inkey.ch"
#include "setcurs.ch"
#include "box.ch"

#define     COLSEP     CHR(32) + CHR(179) + CHR(32)
#define     HEADSEP    CHR(205) + CHR(209) + CHR(205)


/*
*   Routine: UnArch()
*          : 
*   Purpose: Shows bare bones to extract files from a .dbv/fpt file
*          : 
* Arguments: None
*          : 
*  Comments: Could use some assertion added among other stuff which
*          : is up to you to add. Study the code with care.
*          : 
*/
function UnArch()
    local nKey
    local cString
    local cAlias := alias()

    cString := rtrim( (cAlias)->dbfname)
    if !empty( (cAlias)->dbtname )
        cString += ";and;" + rtrim((cAlias)->dbtname)
    endif

    nKey := alert("Extract;" + cString,{"No","Yes"})
    if empty(nKey) .or. nKey == 1
        return nil                                      /* NOTE */
    endif
    *
    *
    * Here you should check for overwritten an exist file....
    *
    *
    cString := "D:\" + rtrim((cAlias)->dbfname)
    if blobexport(N_DBFNAME, cString,BLOB_EXPORT_OVERWRITE)
        alert("Unloaded;" + (cAlias)->dbfname + ";to ramdisk")
    else
        alert("Failed to Unloaded;" + (cAlias)->dbfname + ";to ramdisk")
    endif

    if empty( (cAlias)->dbtname )
        return nil                                      /* NOTE */
    endif

    cString := "D:\" + rtrim((cAlias)->dbtname)
    if blobexport(N_DBTNAME,cString,BLOB_EXPORT_OVERWRITE)
        alert("Unloaded;" + (cAlias)->dbtname + ";to ramdisk")
    else
        alert("Failed to Unloaded;" + (cAlias)->dbtname + ";to ramdisk")
    endif


return nil

/*
*   Routine: ViewNames
*          : 
*   Purpose: Quickie browse
*          : 
* Arguments: None
*          : 
*  Comments: Coded prior to 5.3 Clipper, please excuse brite colors
*          : 
*/
function ViewNames()
    local b
    local nKey
    local cAlias  := alias()
    local cScreen := savescreen(0,0,maxrow(),maxcol())
    local cColor  := setcolor("gr+/b")
    local nCursor := setcursor(0)
    local nRow    := row()
    local nCol    := col()

    set scoreboard off
    cls

    @0,1 say "Viewing [" + cAlias + "]       ENTER=Extract  ESC=Exit browse" 

    b:=tbrowseDb(2,1,maxrow() -2,maxcol() -1)

    dispbox(b:ntop -1,b:nleft -1,b:nbottom +1,b:nright +1,B_DOUBLE+" ")

    b:colorSpec := "W+/B,N/W,W/N,N,GR+/W,N/B,G+/B,GR+/B"
    b:colSep    := COLSEP
    b:headSep   := HEADSEP
    MakeBrow(b)

    while .t.
        Statline(b)
        while (!b:stabilize())
        enddo
        if (b:stable)
            while((nKey := inkey(.5)) == 0)
                Statline(b)
            enddo
        endif

        if !TBMoveCursor(b,nKey)

            if ( nKey == K_ESC )
                scroll()
                exit
            endif
        endif
    enddo
    setcolor(cColor)
    setcursor(nCursor)
    restscreen(0,0,maxrow(),maxcol(),cScreen)
    setpos(nRow,nCol)
    
return (nil)

/*
*   Routine: LowHi
*          : 
*   Purpose: Used in browse above to alter browse headers for fields
*          : 
* Arguments: field name
*          : 
*  Comments: Void
*          : 
*/
static function LowHi(cname)
    cName := strtran(cName,"_",";")
return left(cName,1) + lower(substr(cName,2))


/*
*   Routine: TBMoveCursor
*          : 
*   Purpose: What do you think it does
*          : 
* Arguments: 
*          : 
*  Comments: K_ENTER calls a rountine to extract files
*          : from the .dbv/.fpt file used for archiving
*          : 
*/
static function TBMoveCursor( o, nKey )
    local nFound

    static aKeys_ :=                            ;
    {                                           ;
          K_DOWN      , {|obj| obj:down()},     ;
          K_UP        , {|obj| obj:up()},       ;
          K_PGDN      , {|obj| obj:pageDown()}, ;
          K_PGUP      , {|obj| obj:pageUp()},   ;
          K_CTRL_PGUP , {|obj| obj:goTop()},    ;
          K_CTRL_PGDN , {|obj| obj:goBottom()}, ;
          K_RIGHT     , {|obj| obj:right()},    ;
          K_ENTER     , {|obj| UnArch()},       ;
          K_LEFT      , {|obj| obj:left()}      ;
    }

    nFound := ascan(aKeys_,nKey)
    if (nFound != 0)
        eval( aKeys_[++nFound], o )
    endif
return (nFound != 0)

/*
*   Routine: StatLine
*          : 
*   Purpose: Used by view-browse
*          : 
* Arguments: tbrowse object
*          : 
*  Comments: Void
*          : 
*/
static function Statline(oB)
    local nTop, nRight

    nTop   := oB:nbottom +2
    nRight := oB:nRight

    @ nTop, nRight - 27 say "Record "
    if (lastrec() == 0)
        @ nTop, nRight - 20 say "<none>               "
    elseif ( recno() == lastrec() + 1 )
        @ nTop, nRight - 40 say "         "
        @ nTop, nRight - 20 say "                <new>"
    else
        @ nTop, nRight - 40 say If(Deleted(), "<Deleted>", "         ")
        @ nTop, nRight - 20 say pad(ltrim(str(recno())) + "/"       + ;
                                    ltrim(str(lastrec())), 16)      + ;
                                If(oB:hitTop, "<bof>", "     ")
    endif

return (NIL)

